searchNodes=[{"doc":"Library to easliy implement a Kubernetes controller.","ref":"Bella.html","title":"Bella","type":"module"},{"doc":"Operator configuration interface","ref":"Bella.Config.html","title":"Bella.Config","type":"module"},{"doc":"K8s.Cluster name used for this operator. Defaults to :default","ref":"Bella.Config.html#cluster_name/0","title":"Bella.Config.cluster_name/0","type":"function"},{"doc":"Bella.Controller defines controller behaviours and generates boilerplate for generating Kubernetes manifests. A custom controller is a controller that users can deploy and update on a running cluster, independently of the cluster’s own lifecycle. Custom controllers can work with any kind of resource, but they are especially effective when combined with custom resources. The Operator pattern is one example of such a combination. It allows developers to encode domain knowledge for specific applications into an extension of the Kubernetes API. Controllers allow for simple add , modify , delete , and reconcile handling of custom resources in the Kubernetes API.","ref":"Bella.Controller.html","title":"Bella.Controller","type":"behaviour"},{"doc":"","ref":"Bella.Controller.html#c:add/1","title":"Bella.Controller.add/1","type":"callback"},{"doc":"","ref":"Bella.Controller.html#c:delete/1","title":"Bella.Controller.delete/1","type":"callback"},{"doc":"","ref":"Bella.Controller.html#c:modify/1","title":"Bella.Controller.modify/1","type":"callback"},{"doc":"","ref":"Bella.Controller.html#c:operation/0","title":"Bella.Controller.operation/0","type":"callback"},{"doc":"","ref":"Bella.Controller.html#c:reconcile/1","title":"Bella.Controller.reconcile/1","type":"callback"},{"doc":"Naming functions","ref":"Bella.Naming.html","title":"Bella.Naming","type":"module"},{"doc":"Converts an elixir module name to a string for use as the CRD's kind . Examples iex&gt; Bella.Naming . module_to_kind ( Pod ) &quot;Pod&quot; iex&gt; Bella.Naming . module_to_kind ( Controllers.V1.Pod ) &quot;Pod&quot;","ref":"Bella.Naming.html#module_to_kind/1","title":"Bella.Naming.module_to_kind/1","type":"function"},{"doc":"Extract the CRD API version from the module name. Defaults to &quot;v1&quot; Examples iex&gt; Bella.Naming . module_version ( Pod ) &quot;v1&quot; iex&gt; Bella.Naming . module_version ( Controllers.V1.Pod ) &quot;v1&quot; iex&gt; Bella.Naming . module_version ( Controllers.V1Alpha1.Pod ) &quot;v1alpha1&quot;","ref":"Bella.Naming.html#module_version/1","title":"Bella.Naming.module_version/1","type":"function"},{"doc":"Register periodically run tasks. Use for running tasks as a part of reconciling a CRD with a lifetime, duration, or interval field. Note: Must be started by your operator. Add Bella.PeriodicTask.sttart_link(:ok) to your application. Functions are expected to return one of: :ok - task will be passed to subsequent calls {:ok, new_state} state field will be updated in task and provided to next call {:stop, reason} task will be removed from execution loop. Use for tasks opting out of being re-run any() - any other result is treated as an error, and the execution loop will be halted Examples Registering a task iex&gt; Bella.PeriodicTask . new ( :pod_evictor , { PodEvictor , :evict , [ reconcile_payload_map ] } , 5000 ) Unregistering a task iex&gt; Bella.PeriodicTask . unregister ( :pod_evictor )","ref":"Bella.PeriodicTask.html","title":"Bella.PeriodicTask","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Bella.PeriodicTask.html#child_spec/1","title":"Bella.PeriodicTask.child_spec/1","type":"function"},{"doc":"Registers and starts a new task given Bella.PeriodicTask attributes","ref":"Bella.PeriodicTask.html#new/3","title":"Bella.PeriodicTask.new/3","type":"function"},{"doc":"Registers and starts a new Bella.PeriodicTask","ref":"Bella.PeriodicTask.html#register/1","title":"Bella.PeriodicTask.register/1","type":"function"},{"doc":"","ref":"Bella.PeriodicTask.html#start_link/1","title":"Bella.PeriodicTask.start_link/1","type":"function"},{"doc":"Unregisters and stops a Bella.PeriodicTask","ref":"Bella.PeriodicTask.html#unregister/1","title":"Bella.PeriodicTask.unregister/1","type":"function"},{"doc":"","ref":"Bella.PeriodicTask.html#t:t/0","title":"Bella.PeriodicTask.t/0","type":"type"},{"doc":"Continuously reconciles a set of kubernetes resources. reconcile/1 will be executed asynchronously with each result returned from reconcilable_resources/0 . reconcilable_resources/0 has a default implementation of running K8s.Client.stream/2 with reconcile_operation/0 . For a working example of the Reconciler see Bella.Server.Scheduler Examples Print every pod. Not very useful, but a simple copy-paste example. defmodule PodPrinterReconciler do use Bella.Server.Reconciler , frequency : 15 @impl true def reconcile ( pod ) do IO . inspect ( pod ) :ok end @impl true def reconcile_operation ( ) , do : K8s.Client . list ( &quot;v1&quot; , :pods , namespace : &quot;default&quot; ) @impl true def reconcilable_resources ( ) do operation = reconcile_operation ( ) cluster = Bella.Config . cluster_name ( ) K8s.Client . stream ( operation , cluster ) end end PodPrinterReconciler . start_link ( ) A quick and dirty chaos monkey for pods. 20% chance of eviction every 15 seconds. defmodule ChaosMonkeyReconciler do use Bella.Server.Reconciler , frequency : 15 @percent_chance_evicted 20 @impl true def reconcile ( pod ) do chance = :rand . uniform ( 100 ) if chance &lt; @percent_chance_evicted do my_function_to_evict_pod ( pod ) end :ok end @impl true def reconcile_operation ( ) , do : K8s.Client . list ( &quot;v1&quot; , :pods , namespace : :all ) @impl true def reconcilable_resources ( ) do operation = reconcile_operation ( ) cluster = Bella.Config . cluster_name ( ) K8s.Client . stream ( operation , cluster ) end end ChaosMonkeyReconciler . start_link ( ) Reconcile a CRD's resources every 15 seconds defmodule MyCustomResourceReconciler do use Bella.Server.Reconciler , frequency : 15 @impl true def reconcile ( resource ) do # You should do something much cooler than inspect here... IO . inspect ( resource ) :ok end @impl true def reconcile_operation ( ) do K8s.Client . list ( &quot;example.com/v1&quot; , &quot;MyCustomResourceDef&quot; , namespace : :all ) end @impl true def reconcilable_resources ( ) do operation = reconcile_operation ( ) cluster = Bella.Config . cluster_name ( ) K8s.Client . stream ( operation , cluster ) end end MyCustomResourceReconciler . start_link ( )","ref":"Bella.Server.Reconciler.html","title":"Bella.Server.Reconciler","type":"behaviour"},{"doc":"(Optional) List of resources to be reconciled. Default implementation is to stream all resources ( reconcile_operation/0 ) from the cluster ( Bella.Config.cluster_name/0 ).","ref":"Bella.Server.Reconciler.html#c:reconcilable_resources/0","title":"Bella.Server.Reconciler.reconcilable_resources/0","type":"callback"},{"doc":"Reconciles a resource. This will receive a list of resources from reconcilable_resources/0 .","ref":"Bella.Server.Reconciler.html#c:reconcile/1","title":"Bella.Server.Reconciler.reconcile/1","type":"callback"},{"doc":"K8s.Operation to reconcile. Examples def reconcile_operation ( ) do K8s.Client . list ( &quot;v1&quot; , :pods , namespace : :all ) end","ref":"Bella.Server.Reconciler.html#c:reconcile_operation/0","title":"Bella.Server.Reconciler.reconcile_operation/0","type":"callback"},{"doc":"Runs a Reconcilers reconcile/1 for each resource return by reconcilable_resources/0","ref":"Bella.Server.Reconciler.html#run/1","title":"Bella.Server.Reconciler.run/1","type":"function"},{"doc":"Schedules a run of a started Reconciler","ref":"Bella.Server.Reconciler.html#schedule/2","title":"Bella.Server.Reconciler.schedule/2","type":"function"},{"doc":"Continuously watch a list Operation for add , modify , and delete events.","ref":"Bella.Server.Watcher.html","title":"Bella.Server.Watcher","type":"behaviour"},{"doc":"","ref":"Bella.Server.Watcher.html#c:add/1","title":"Bella.Server.Watcher.add/1","type":"callback"},{"doc":"","ref":"Bella.Server.Watcher.html#c:delete/1","title":"Bella.Server.Watcher.delete/1","type":"callback"},{"doc":"Dispatches an ADDED , MODIFIED , and DELETED events to an controller","ref":"Bella.Server.Watcher.html#dispatch/2","title":"Bella.Server.Watcher.dispatch/2","type":"function"},{"doc":"","ref":"Bella.Server.Watcher.html#c:modify/1","title":"Bella.Server.Watcher.modify/1","type":"callback"},{"doc":"","ref":"Bella.Server.Watcher.html#process_line/3","title":"Bella.Server.Watcher.process_line/3","type":"function"},{"doc":"","ref":"Bella.Server.Watcher.html#process_lines/3","title":"Bella.Server.Watcher.process_lines/3","type":"function"},{"doc":"","ref":"Bella.Server.Watcher.html#watch/3","title":"Bella.Server.Watcher.watch/3","type":"function"},{"doc":"K8s.Operation to watch. Examples Log all pod lifecycle events defmodule PodLifecycleLogger do use Bella.Server.Watcher @impl true def watch_operation ( ) do K8s.Client . list ( &quot;v1&quot; , :pods , namespace : :all ) end @impl true def add ( pod ) do log_event ( :add , pod ) end @impl true def modify ( pod ) do log_event ( :modify , pod ) end @impl true def delete ( pod ) do log_event ( :delete , pod ) end @spec log_event ( atom , map ) :: :ok def log_event ( type , pod ) do name = get_in ( pod , [ &quot;metadata&quot; , &quot;name&quot; ] ) namespace = get_in ( pod , [ &quot;metadata&quot; , &quot;namepace&quot; ] ) || &quot;default&quot; # log type,name,namespace here end end","ref":"Bella.Server.Watcher.html#c:watch_operation/0","title":"Bella.Server.Watcher.watch_operation/0","type":"callback"},{"doc":"Get the resourceVersion for a K8s.Operation","ref":"Bella.Server.Watcher.ResourceVersion.html","title":"Bella.Server.Watcher.ResourceVersion","type":"module"},{"doc":"","ref":"Bella.Server.Watcher.ResourceVersion.html#extract_rv/1","title":"Bella.Server.Watcher.ResourceVersion.extract_rv/1","type":"function"},{"doc":"","ref":"Bella.Server.Watcher.ResourceVersion.html#get/2","title":"Bella.Server.Watcher.ResourceVersion.get/2","type":"function"},{"doc":"Buffers streaming responses from HTTPoison and returns kubernetes watch events as JSON ResponseBuffer implementation from Kazan 's LineBuffer.","ref":"Bella.Server.Watcher.ResponseBuffer.html","title":"Bella.Server.Watcher.ResponseBuffer","type":"module"},{"doc":"Add an HTTP response chunk to the buffer","ref":"Bella.Server.Watcher.ResponseBuffer.html#add_chunk/2","title":"Bella.Server.Watcher.ResponseBuffer.add_chunk/2","type":"function"},{"doc":"Returns complete lines of JSON from streaming HTTP Response. Lines are in NDJSON format; each line is a JSON object.","ref":"Bella.Server.Watcher.ResponseBuffer.html#get_lines/1","title":"Bella.Server.Watcher.ResponseBuffer.get_lines/1","type":"function"},{"doc":"Create a new ResponseBuffer","ref":"Bella.Server.Watcher.ResponseBuffer.html#new/0","title":"Bella.Server.Watcher.ResponseBuffer.new/0","type":"function"},{"doc":"","ref":"Bella.Server.Watcher.ResponseBuffer.html#t:t/0","title":"Bella.Server.Watcher.ResponseBuffer.t/0","type":"type"},{"doc":"State of the Watcher","ref":"Bella.Server.Watcher.State.html","title":"Bella.Server.Watcher.State","type":"module"},{"doc":"","ref":"Bella.Server.Watcher.State.html#new/0","title":"Bella.Server.Watcher.State.new/0","type":"function"},{"doc":"","ref":"Bella.Server.Watcher.State.html#t:t/0","title":"Bella.Server.Watcher.State.t/0","type":"type"},{"doc":"Bella.Sys.Event is a thin wrapper around :telemetry . All events will be prefixed with bella . The following events are emitted: [:bella, :task, :stopped] [:bella, :task, :failed] [:bella, :task, :succeeded] [:bella, :task, :unregistered] [:bella, :task, :registered] [:bella, :task, :initialized] [:bella, :scheduler, :binding, :failed] [:bella, :scheduler, :binding, :succeeded] [:bella, :scheduler, :nodes, :fetch, :failed] [:bella, :scheduler, :nodes, :fetch, :succeeded] [:bella, :scheduler, :pods, :fetch, :failed] [:bella, :scheduler, :pods, :fetch, :succeeded] [:bella, :reconciler, :genserver, :down] [:bella, :reconciler, :reconcile, :failed] [:bella, :reconciler, :reconcile, :succeeded] [:bella, :reconciler, :run, :started] [:bella, :reconciler, :fetch, :failed] [:bella, :reconciler, :fetch, :succeeded] [:bella, :reconciler, :initialized] [:bella, :watcher, :genserver, :down] [:bella, :watcher, :chunk, :received] [:bella, :watcher, :watch, :timedout] [:bella, :watcher, :watch, :failed] [:bella, :watcher, :watch, :finished] [:bella, :watcher, :watch, :succeeded] [:bella, :watcher, :watch, :started] [:bella, :watcher, :initialized] To access this list programmatically use events/0 . If set, default metadata will be applied to all events. See: metadata/0","ref":"Bella.Sys.Event.html","title":"Bella.Sys.Event","type":"module"},{"doc":"Returns a list of all events emitted by this module: [:bella, :task, :stopped] [:bella, :task, :failed] [:bella, :task, :succeeded] [:bella, :task, :unregistered] [:bella, :task, :registered] [:bella, :task, :initialized] [:bella, :scheduler, :binding, :failed] [:bella, :scheduler, :binding, :succeeded] [:bella, :scheduler, :nodes, :fetch, :failed] [:bella, :scheduler, :nodes, :fetch, :succeeded] [:bella, :scheduler, :pods, :fetch, :failed] [:bella, :scheduler, :pods, :fetch, :succeeded] [:bella, :reconciler, :genserver, :down] [:bella, :reconciler, :reconcile, :failed] [:bella, :reconciler, :reconcile, :succeeded] [:bella, :reconciler, :run, :started] [:bella, :reconciler, :fetch, :failed] [:bella, :reconciler, :fetch, :succeeded] [:bella, :reconciler, :initialized] [:bella, :watcher, :genserver, :down] [:bella, :watcher, :chunk, :received] [:bella, :watcher, :watch, :timedout] [:bella, :watcher, :watch, :failed] [:bella, :watcher, :watch, :finished] [:bella, :watcher, :watch, :succeeded] [:bella, :watcher, :watch, :started] [:bella, :watcher, :initialized] Great for use with :telemetry.attach_many/4","ref":"Bella.Sys.Event.html#events/0","title":"Bella.Sys.Event.events/0","type":"function"},{"doc":"Measure function execution in ms and return in map w/ results. Examples iex&gt; Bella.Sys.Event . measure ( IO , :puts , [ &quot;hello&quot; ] ) { %{ duration : 33 } , :ok }","ref":"Bella.Sys.Event.html#measure/3","title":"Bella.Sys.Event.measure/3","type":"function"},{"doc":"Default metadata added to all events. Defaults: %{}","ref":"Bella.Sys.Event.html#metadata/0","title":"Bella.Sys.Event.metadata/0","type":"function"},{"doc":"Merges metadata with defaults","ref":"Bella.Sys.Event.html#metadata/1","title":"Bella.Sys.Event.metadata/1","type":"function"},{"doc":"The instrumenter name","ref":"Bella.Sys.Event.html#name/0","title":"Bella.Sys.Event.name/0","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#reconciler_fetch_failed/2","title":"Bella.Sys.Event.reconciler_fetch_failed/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#reconciler_fetch_succeeded/2","title":"Bella.Sys.Event.reconciler_fetch_succeeded/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#reconciler_genserver_down/2","title":"Bella.Sys.Event.reconciler_genserver_down/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#reconciler_initialized/2","title":"Bella.Sys.Event.reconciler_initialized/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#reconciler_reconcile_failed/2","title":"Bella.Sys.Event.reconciler_reconcile_failed/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#reconciler_reconcile_succeeded/2","title":"Bella.Sys.Event.reconciler_reconcile_succeeded/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#reconciler_run_started/2","title":"Bella.Sys.Event.reconciler_run_started/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#scheduler_binding_failed/2","title":"Bella.Sys.Event.scheduler_binding_failed/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#scheduler_binding_succeeded/2","title":"Bella.Sys.Event.scheduler_binding_succeeded/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#scheduler_nodes_fetch_failed/2","title":"Bella.Sys.Event.scheduler_nodes_fetch_failed/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#scheduler_nodes_fetch_succeeded/2","title":"Bella.Sys.Event.scheduler_nodes_fetch_succeeded/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#scheduler_pods_fetch_failed/2","title":"Bella.Sys.Event.scheduler_pods_fetch_failed/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#scheduler_pods_fetch_succeeded/2","title":"Bella.Sys.Event.scheduler_pods_fetch_succeeded/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#task_failed/2","title":"Bella.Sys.Event.task_failed/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#task_initialized/2","title":"Bella.Sys.Event.task_initialized/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#task_registered/2","title":"Bella.Sys.Event.task_registered/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#task_stopped/2","title":"Bella.Sys.Event.task_stopped/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#task_succeeded/2","title":"Bella.Sys.Event.task_succeeded/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#task_unregistered/2","title":"Bella.Sys.Event.task_unregistered/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#watcher_chunk_received/2","title":"Bella.Sys.Event.watcher_chunk_received/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#watcher_genserver_down/2","title":"Bella.Sys.Event.watcher_genserver_down/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#watcher_initialized/2","title":"Bella.Sys.Event.watcher_initialized/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#watcher_watch_failed/2","title":"Bella.Sys.Event.watcher_watch_failed/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#watcher_watch_finished/2","title":"Bella.Sys.Event.watcher_watch_finished/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#watcher_watch_started/2","title":"Bella.Sys.Event.watcher_watch_started/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#watcher_watch_succeeded/2","title":"Bella.Sys.Event.watcher_watch_succeeded/2","type":"function"},{"doc":"","ref":"Bella.Sys.Event.html#watcher_watch_timedout/2","title":"Bella.Sys.Event.watcher_watch_timedout/2","type":"function"},{"doc":"Attaches telemetry events to the Elixir Logger","ref":"Bella.Sys.Logger.html","title":"Bella.Sys.Logger","type":"module"},{"doc":"Attaches telemetry events to the Elixir Logger","ref":"Bella.Sys.Logger.html#attach/0","title":"Bella.Sys.Logger.attach/0","type":"function"},{"doc":"This is a goofy config, but it makes this work in dev w/o having to POST an Example CRD. This controller simply logs lifecycle events on Deployments.","ref":"DeploymentEventLogController.html","title":"DeploymentEventLogController","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"DeploymentEventLogController.html#child_spec/1","title":"DeploymentEventLogController.child_spec/1","type":"function"},{"doc":"","ref":"DeploymentEventLogController.html#start_link/1","title":"DeploymentEventLogController.start_link/1","type":"function"},{"doc":"","ref":"DeploymentEventLogController.html#track_event/2","title":"DeploymentEventLogController.track_event/2","type":"function"},{"doc":"Bella: Kubernetes Controller Framework Bella make it easy to create Kubernetes Controllers.","ref":"readme.html","title":"Bella: Kubernetes Controller Framework","type":"extras"},{"doc":"Bella can be installed by adding bella to your list of dependencies in mix.exs : def deps do [ { :bella , &quot;~&gt; 0.0.1&quot; } ] end Configuration Bella uses the k8s client under the hood. config :k8s , clusters : %{ default : %{ # `default` here must match `cluster_name` below conn : &quot;~/.kube/config&quot; } } # K8s.Cluster to use, defaults to :default cluster_name : :default","ref":"readme.html#installation","title":"Bella: Kubernetes Controller Framework - Installation","type":"extras"},{"doc":"Bella uses the telemetry and notion library to emit event metrics. Events: Bella.Sys.Event.events() [ [ :bella , :reconciler , :genserver , :down ] , [ :bella , :reconciler , :reconcile , :failed ] , [ :bella , :reconciler , :reconcile , :succeeded ] , [ :bella , :reconciler , :run , :started ] , [ :bella , :reconciler , :fetch , :failed ] , [ :bella , :reconciler , :fetch , :succeeded ] , [ :bella , :reconciler , :initialized ] , [ :bella , :watcher , :genserver , :down ] , [ :bella , :watcher , :chunk , :received ] , [ :bella , :watcher , :watch , :timedout ] , [ :bella , :watcher , :watch , :failed ] , [ :bella , :watcher , :watch , :finished ] , [ :bella , :watcher , :watch , :succeeded ] , [ :bella , :watcher , :watch , :started ] , [ :bella , :watcher , :initialized ] ]","ref":"readme.html#telemetry","title":"Bella: Kubernetes Controller Framework - Telemetry","type":"extras"},{"doc":"Controller : A custom controller is a controller that users can deploy and update on a running cluster, independently of the cluster’s own lifecycle. Custom controllers can work with any kind of resource, but they are especially effective when combined with custom resources. The Operator pattern is one example of such a combination. It allows developers to encode domain knowledge for specific applications into an extension of the Kubernetes API.","ref":"readme.html#terminology","title":"Bella: Kubernetes Controller Framework - Terminology","type":"extras"},{"doc":"mix test","ref":"readme.html#testing","title":"Bella: Kubernetes Controller Framework - Testing","type":"extras"},{"doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added @impl to macros for clean compilation error handling for mid-stream errors","ref":"changelog.html#0-4-4-2021-08-09","title":"Changelog - [0.4.4] - 2021-08-09","type":"extras"},{"doc":"Added Configure watched namespace via config.exs or BONNY_POD_NAMESPACE BONNY POD NAMESPACE supports &quot;magic&quot; value &quot;__ALL &quot;","ref":"changelog.html#0-4-3-2020-06-09","title":"Changelog - [0.4.3] - 2020-06-09","type":"extras"},{"doc":"Added Support for reconciling/watching core resources","ref":"changelog.html#0-4-1-2019-11-26","title":"Changelog - [0.4.1] - 2019-11-26","type":"extras"},{"doc":"Added Basic integration w/ Notion for telemetry Bonny.Server.Reconciler continually process a list operation Bonny.Server.Scheduler write custom kubernetes schedulers Added Bonny.PeriodicTask for scheduling periodically executed functions Changed Dockerfile gen uses OTP releases Removed Removed reconcile_batch_size","ref":"changelog.html#0-4-0-2019-10-23","title":"Changelog - [0.4.0] - 2019-10-23","type":"extras"},{"doc":"Added Add additional printer columns Bonny.Naming module .credo.exs","ref":"changelog.html#0-3-3-2019-06-25","title":"Changelog - [0.3.3] - 2019-06-25","type":"extras"},{"doc":"Added Bonny.Watcher and Bonny.Reconciler telemetry events","ref":"changelog.html#0-3-2-2019-04-15","title":"Changelog - [0.3.2] - 2019-04-15","type":"extras"},{"doc":"Added Support for a reconcile/1 callback reconcile_every config option to schedule how often to run reconciliation reconcile_batch_size to set the size of the HTTP GET limit when fetching batches of items to reconcile Added {:error, binary} as a return value of Controller lifecycle methods Implemented :telemetry library Bonny.Sys.Event.events/0 exposes list of telemetry events mix bonny.gen.manifest --local for building manifests w/o a Deployment for local testing cluster_name: :default config options. Now uses k8s cluster registration configuration. Changed Async watcher event dispatch Replaced HTTPoison with k8s Fixed Receiving :DOWN messages no longer crashes Watcher #20 Issue with partially received events #43 Fix invalid singular name generation from module names &quot;MyMod&quot; -&gt; my_mod; &quot;MyMod&quot; -&gt; mymod Removed Renamed group_version -&gt; api_version Renamed Bonny.CRD.plural/1 -&gt; Bonny.CRD.kind/1 Bypass from test suite Impl.parse_metadata/1 kubeconf_file and kubeconf_opts config options","ref":"changelog.html#0-3-1-2019-04-11","title":"Changelog - [0.3.1] - 2019-04-11","type":"extras"},{"doc":"Changed Replaced k8s_conf library with k8s .","ref":"changelog.html#0-3-0-2019-03-04","title":"Changelog - [0.3.0] - 2019-03-04","type":"extras"},{"doc":"Added Initial public release. Controller lifecycle implementation. CRD Watcher. mix task: controller generator mix task: dockerfile generator mix task: k8s manifest generator","ref":"changelog.html#0-2-3-2019-01-13","title":"Changelog - [0.2.3] - 2019-01-13","type":"extras"}]